#!/usr/bin/perl
###############################################################################
# Moderator facilities for Web message Board                                  #
# Last Modified 1999-11-02 by Agner Fog                                       #
#                                                                             #
# Please see readme.txt for instructions                                      #
###############################################################################

###############################################################################
#                   Define filenames, directories, options                    #
###############################################################################

$ext1 = 'shtml';  # extension for index files
$ext2 = 'htm';    # extension for other files

$basedir = '..';
$baseurl = '..';
$_ = $0; s/.*\///;
$cgi_url = "/cgi-bin/$_";
$msgdir  = 'messages';       # subdirectory for messages
$olddir  = 'old';            # subdirectory for old messages
$deletedir = 'deleted';      # subdirectory for deleted messages
$indexfile = "index.$ext1";  # main index
$uindex = "uindex.$ext1";    # unthreaded index
$oindex = "oindex.$ext1";    # index of old messages
$dindex = "dindex.$ext1";    # index of deleted messages
$faqfile = "faq.$ext2";      # board faq
$helpfile = '../boardsetup/modhelp.htm';  # moderation help file
$passwordfile = '~/moderators.txt'; # name of password file
$logfile = '~/moderate.log'; # moderation log
$logo = 'm.gif';             # logo image

# Define Options
#colors of text, background and links:
$colors = 'text="#000000" bgcolor="#D0FFFF" link="#0000E0" vlink="#E000E0"';
$ecolor = "#FF0000";  #color of error messages
$mcolor = "#E03000";  #color of moderation comments
$gmt = 1;	      # use Greenwich Mean Time
$maxlistlength = 500; # max number of threads to move or purge in one operation


###############################################################################
#                      owerall branching
###############################################################################

# Get Form Information
&parse_form;

# Put items into nice variables
&get_variables;

if (!$command) {
   #first call: make form
   &make_form;
   exit;}

&check_permission;

if ($command == 2) {
   # second call
   if ($action =~ /disk/) {
      &disk_use;}
   else {
      &make_message_list;
      &make_feedback;}}

elsif ($command == 3) {
   # third call
   if ($action eq 'edit') {
      &edit_message;}
   elsif ($action =~ /mov/) {
      &move;
      &feedback_success;}
   elsif ($action =~ /purg/) {
      &purge;
      &feedback_success;}
   elsif ($action =~ /rest/) {
      &restore;
      &feedback_success;}
   else {
      &error ("unknown action $action");}}
elsif ($command == 4) {
   # finished editing
   &finish_edit;}

else {
   &error ("unknown command $command");}


###############################################################################
#                      initial procedures
###############################################################################

# Parse Form Subroutine
sub parse_form {
   # Get the input
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

   # Split the name-value pairs
   @pairs = split(/&/, $buffer);

   foreach $pair (@pairs) {
      # Un-Webify plus signs and %-encoding
      ($nam, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/eg;
      $FORM{$nam} = $value;}}

sub get_variables {
   $command = $FORM{'command'};
   $board = $FORM{'board'};
   $action = $FORM{'action'};
   $basedir .= "/$board";
   $baseurl .= "/$board";
   $threads = $FORM{'threads'};
   $messages = $FORM{'messages'};
   $moderator = $FORM{'moderator'};
   $passw = $FORM{'passw'};
   $reason = $FORM{'reason'};
   $directory = $FORM{'directory'};
   $list_type = $FORM{'list_type'};
   $message_list = $FORM{'message_list'};

   # read board names and passwords
   open FIL, "<$passwordfile" or &error("cannot open $passwordfile");
   @lines = <FIL>; close FIL;
   foreach $line (@lines) {
      $line =~ s/\n//g;
      if (length($line) > 2 and !($line =~ /\#.*/)) {
         if ($line =~ /boards( *)=/) {
            # get names of boards
            ($b,$l) = split (/=/, $line);
            @boards = split (/[, ]+/, $l);
            foreach $b (@boards) {
               $b =~ s/\s//g;}}
         else {
            # get password and permissions for each moderator
            $line =~ /(\A[^\s,]+)[ ,]+([^\s,]+)[, ]+(.*)/;
            if ($1 && $2 && $3) {
               $passwordlist{$1} = $2;
               $boardlist{$1} = $3;}}}}

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = $gmt ? gmtime(time) : localtime(time);
   if ($sec < 10) {$sec = "0$sec";}
   if ($min < 10) {$min = "0$min";}
   if ($hour < 10) {$hour = "0$hour";}
   $mon++;
   if ($mon < 10) {$mon = "0$mon";}
   if ($mday < 10) {$mday = "0$mday";}
   if ($year < 90) {$long_year = "20$year";} else {$long_year = "19$year";}
   $date = "$long_year-$mon-$mday";
   $date_time = "$date $hour\:$min\:$sec";}


sub make_form {
   print "Content-type: text/html\n\n<html><head>\n";
   print "<title>Moderation</title></head>\n<body $colors><font face=\"arial\">\n";
   print "<center><h2>Web Board Moderation</h2><hr><p>\n";
   print "[ <a href=\"$helpfile\" accesskey='h'><span class='hotkey'>H</span>elp</a> ]\n";
   print "<form method=POST action=\"$cgi_url\">\n";
   print "<input type='hidden' name=\"command\" value=\"2\">\n";
   print "<table border=0 cellspacing=8><tr><td><font face=\"arial\">Board:<br>\n";
   print "<select name=\"board\" size=1>\n"; $_ = " selected";
   foreach $board(@boards) {
      if ($board) {
         print "<option$_>$board</option>\n";  $_='';}}
   print "</select></font></td>\n";
   print "<td><font face=\"arial\">Action:<br><select name=\"action\" size=1>\n";
   print "<option selected value=\"edit\">edit message</option>\n";
   print "<option value=\"movold\">move to old</option>\n";
   print "<option value=\"restold\">restore old</option>\n";
   print "<option value=\"purgold\">purge from old</option>\n";
   print "<option value=\"movdel\">move to deleted</option>\n";
   print "<option value=\"restdel\">restore deleted</option>\n";
   print "<option value=\"purgdel\">purge from deleted</option>\n";
   print "<option value=\"diskuse\">disk use this board</option>\n";
   print "<option value=\"diskall\">disk use all boards</option>\n";
   print "</select></font></td></tr>\n";
   print "<tr><td><font face=\"arial\">Thread(s):<br><input type=text name=\"threads\" size=30></font></td>\n";
   print "<td><font face=\"arial\">Message(s):<br><input type=text size=30 name=\"messages\"></font></td></tr>\n";
   print "<tr><td><font face=\"arial\">Moderator:<br><input type=text name=\"moderator\" size=30></font></td>\n";
   print "<td><font face=\"arial\">Password:<br><input type=password size=30 name=\"passw\"></font></td></tr>\n";
   print "<tr><td colspan=2><font face=\"arial\">Reason if deleting:<br><input type=text name=\"reason\" size=62></font></td></tr>\n";
   print "</table><p>\n";
   print "<input type=submit value=' OK ' accesskey='o'> <input type=reset value='reset' accesskey='r'> ";
   print "<input type=button value='Cancel' onClick='history.go(-1)' accesskey='c'></form>";
   print "<p><hr><p>\n</font></body></html>\n";}


sub make_feedback {
   $error = 0;
   print "Content-type: text/html\n\n<html><head>\n";
   print "<title>Moderation</title></head>\n<body $colors><font face=\"arial\">\n";
   print "<h3 align=center>Web Board Moderation</h3><h1>";
   if ($logo) {
      print "<img align=left src=\"$baseurl/$msgdir/$logo\"> &nbsp;\n";}
   print "$action</h1><hr><center>\n";
   print "[ <a href=\"$helpfile\" accesskey='h'><span class='hotkey'>H</span>elp</a> ] ";
   print "[ <a href=\"$baseurl/$faqfile\" accesskey='f'><span class='hotkey'>F</span>AQ</a> ] </center>";
   print "<h3>Selected ";
   if ($list_type > 1) {print "threads";} else {print "messages"};
   print "</h3><p>\n";
   foreach $message(@message_list) {
      print "<a href=\"$baseurl/$directory/$message\">$message</a>\n";
      if ($directory eq $msgdir and $action =~ /mov/) {
         $message =~ /(\d+)-(\d+)\./;
         $thread = $1; $num = $2;
         $last_fo_date = $last_fo_thread = $last_fo_num = 0;
         $filename = "$basedir/$msgdir/$thread-1\.$ext1";
         &find_followups;
         if ($last_fo_num > $num) {
            $fo = "$thread-$last_fo_num\.$ext2";
            if ($num == 1 and $list_type < 2) {
               print "<font color=$ecolor>Error: cannot move thread index without moving entire thread.</font>\n";
               $error = 1;}
            print " - Last follow-up: <a href=\"$baseurl/$msgdir/$fo\">$fo</a> <i>$last_fo_date</i>\n";}}
      elsif ($action =~ /purg/ or $action =~ /rest/) {
         if ($action =~ /del/) {$dir2 = $deletedir;} else {$dir2 =$olddir;}
         $message =~ /(\d+)-(\d+)\./;
         $thread = $1; $num = $2;
         if ($num == 1 and $list_type < 2) {
            $filename = "$basedir/$dir2/$thread-1\.$ext1";
            if (-e $filename) {
               $last_fo_num = 0;
               &find_followups;
               if ($last_fo_num > $num) {
                  if ($action =~ /purg/) {$m = 'remov';} else {$m = 'restor';}
                  print "<font color=$ecolor>Error: cannot $m"."e thread index $message without $m"."ing entire thread.</font>\n";
                  $error = 1;}}}}
      print "<br>\n";}

   $threads = ''; $numbers = '';
   unless ($error) {
      print "<hr><center><form method=POST action=\"$cgi_url\">\n";
      print "<input type='hidden' name=\"command\" value=\"3\">\n";
      print "<input type='hidden' name=\"board\" value=\"$board\">\n";
      print "<input type='hidden' name=\"action\" value=\"$action\">\n";
      print "<input type='hidden' name=\"moderator\" value=\"$moderator\">\n";
      print "<input type='hidden' name=\"passw\" value=\"$passw\">\n";
      print "<input type='hidden' name=\"reason\" value=\"$reason\">\n";
      print "<input type='hidden' name=\"directory\" value=\"$directory\">\n";
      print "<input type='hidden' name=\"list_type\" value=\"$list_type\">\n";
      $_ = join(',',@thread_list);
      print "<input type='hidden' name=\"thread_list\" value=\"$_\">\n";
      $_ = join(',',@msg_num_list);
      print "<input type='hidden' name=\"msg_num_list\" value=\"$_\">\n";
      $_ = join(',',@message_list);
      print "<input type='hidden' name=\"message_list\" value=\"$_\">\n";
      print "<input type=submit value=' GO ' accesskey='g'> ";
      print "<input type=button value='Cancel' onClick='history.go(-1)' accesskey='c'>";
      print "</form><p></center><hr><p>\n";}
   print "</font></body></html>\n";}


###############################################################################
#                      actions
###############################################################################


# present message in text field for editing
sub edit_message {
   $filename = "$basedir/$directory/$message_list";
   open FIL, "$filename" or &error("Edit: cannot open $filename");
   @lines = <FIL>;  close FIL;
   $lines = join '', @lines;
   $lines =~ /<hr>((.|\n)*)<hr>/;
   $head = "$`<hr>"; $body = $1; $tail = "<hr>$'";    # $&

   print "Content-type: text/html\n\n<html><head>\n";
   print "<title>Moderation</title></head>\n<body $colors><font face=\"arial\">\n<h1>";
   if ($logo and $board) {
      print "<img align=left src=\"$baseurl/$msgdir/$logo\"> &nbsp;\n";}
   print "Edit message</h1><p>\n";
   print "<hr><form method=POST action=\"$cgi_url\">\n";
   print "<input type='hidden' name=\"command\" value=\"4\">\n";
   print "<input type='hidden' name=\"board\" value=\"$board\">\n";
   print "<input type='hidden' name=\"moderator\" value=\"$moderator\">\n";
   print "<input type='hidden' name=\"passw\" value=\"$passw\">\n";
   print "<input type='hidden' name=\"directory\" value=\"$directory\">\n";
   print "<input type='hidden' name=\"message_list\" value=\"$message_list\">\n";
   print "Head:<br>\n";
   print "<textarea name=\"head\" COLS=60 ROWS=8 wrap=virtual>";
   print "$head</textarea><p>\n";
   print "Body:<br>\n";
   print "<textarea name=\"body\" COLS=60 ROWS=16 wrap=virtual>";
   print "$body</textarea><p>\n";
   print "Tail:<br>\n";
   print "<textarea name=\"tail\" COLS=60 ROWS=8 wrap=virtual>";
   print "$tail</textarea><p>\n<center>";
   print "<input type=submit value=' GO ' accesskey='g'> ";
   print "<input type=button value='Cancel' onClick='history.go(-2)' accesskey='c'>";
   print "</center></form><p><hr><p>\n";
   print "</font></body></html>\n";}


sub finish_edit {
   # store edited file
   $filename = "$basedir/$directory/$message_list";
   open FIL, ">$filename" or &error("Edit: cannot write $filename");
   $FORM{'body'} =~ s/<m>/<font color\=$mcolor>/ig;
   $FORM{'body'} =~ s/<\/m>/<\/font>/ig;
   print FIL $FORM{'head'};
   print FIL $FORM{'body'};
   print FIL $FORM{'tail'};
   close FIL;
   &write_log ("File edited. Moderator=$moderator, Board=$board, $filename");
   # return success:
   print "Content-type: text/html\n\n<html><head>\n";
   print "<title>Moderation</title></head>\n<body $colors>\n<h1>";
   if ($logo) {
      print "<img align=left src=\"$baseurl/$msgdir/$logo\"> &nbsp;\n";}
   print "File edited successfully</h1><hr><p>\n";
   print "<a href=\"$baseurl/$directory/$message_list\" accesskey='v'><span class='hotkey'>V</span>iew edited file</a> ";
   if (not $message_list =~ /\.sht/) {
      print " and remember to press <b>reload</b>";}
   print "<br>\n</body></html>\n";}


sub move {
   # move one or more messages to 'deleted' or 'old'
   if ($action eq 'movdel') {
      $dir2 = $deletedir; $index2 = $dindex; $reason = $FORM{'reason'};
      if (not $reason) {&error ("Reason for deleting missing");}}
   else {
      $dir2 =$olddir; $index2 = $oindex; $reason = '';}
   @thread_list = split(/,/, $FORM{'thread_list'});
   @msg_num_list = split(/,/, $FORM{'msg_num_list'}); $nmov = 0;

   if ($list_type > 1) {
      #move one or more entire threads
      foreach $thread (@thread_list) {
         $messagefile = $filename = "$basedir/$msgdir/$thread-1.$ext1";
         &find_contents;
         &remove_thread_from_main_index;
         &remove_thread_from_uindex;
         $filename = "$basedir/$msgdir/$thread-1\.$ext1"; $num = 1;
         &find_followups;
         $filename = "$basedir/$index2";
         &add_to_index;
         foreach $oldname (<$basedir/$msgdir/$thread-*.*>) {
            $filename = $oldname;
            &hide_button;
            $newname = $oldname;
            $newname =~ s/$basedir\/$msgdir\//$basedir\/$dir2\//;
            rename ($oldname,$newname) or &error ("cannot move $oldname to $newname");
            $nmov++;}}
      $threads = join (',',@thread_list);
      &write_log ("$action. Moderator=$moderator, Board=$board, Threads=$threads");}
   else {
      # move one or more messages in same thread
      $thread = $thread_list[0];
      foreach $msg_num (@msg_num_list) {
         $messagefile = $filename = "$basedir/$msgdir/$thread-$msg_num." . (($msg_num == 1) ? $ext1 : $ext2);
         $num = $msg_num; $filename = "$basedir/$msgdir/$thread-1\.$ext1";
         &find_followups;
         $previous = $next = 0; $filename = $messagefile;
         &find_contents;
         push (@followups,$previous,$next);
         foreach $num (@followups) {
            # remove cross-links from all other messages
            if ($num) {&change_links;}}
         $num = $msg_num;
         $filename = "$basedir/$msgdir/$thread-1.$ext1";
         &remove_from_thread_index;
         &remove_from_uindex;
         $filename = $messagefile;
         &hide_button;
         &hide_links;
         $filename = "$basedir/$index2";
         &add_to_index;
         $newname = $oldname = $messagefile;
         $newname =~ s/$basedir\/$msgdir\//$basedir\/$dir2\//;
         rename ($oldname,$newname) or &error ("cannot move $oldname to $newname");
         $nmov++;
         $num = $msg_num;}
      $messages = join (',',@msg_num_list);
      &write_log ("$action. Moderator=$moderator, Board=$board, Thread=$thread, Messages=$messages");}}

sub purge {
   # purge old messages from old or deleted
   if ($action eq 'purgdel') {
      $dir2 = $deletedir; $index2 = $dindex;}
   else {
      $dir2 =$olddir; $index2 = $oindex;}
   @thread_list = split(/,/, $FORM{'thread_list'});
   @msg_num_list = split(/,/, $FORM{'msg_num_list'});
   $ndel = 0;

   if ($list_type > 1) {
      # purge one or more entire threads
      foreach $thread (@thread_list) {
         $filename = "$basedir/$index2"; $num = 0;
         &remove_from_index;
         $ndel += unlink <$basedir/$dir2/$thread-*.*>;}
      $threads = join (',',@thread_list);
      &write_log ("$action. Moderator=$moderator, Board=$board, Threads=$threads");}
   else {
      # purge one or more messages in same thread
      $thread = $thread_list[0];
      foreach $msg_num (@msg_num_list) {
         # search for thread index
         $filename = "$basedir/$dir2/$thread-1.$ext1";
         if (-e $filename) {
            $num = $msg_num;
				&remove_from_thread_index;}
         $filename = "$basedir/$index2"; $num = $msg_num;
         &remove_from_index;
         $ndel += unlink <$basedir/$dir2/$thread-$num.*>;}
      $messages = join (',',@msg_num_list);
      &write_log ("$action. Moderator=$moderator, Board=$board, Thread=$thread, Messages=$messages");}}


sub restore {
   # restore old messages from old or deleted
   if ($action eq 'restdel') {
      $dir2 = $deletedir; $index2 = $dindex;}
   else {
      $dir2 =$olddir; $index2 = $oindex;}
   @thread_list = split(/,/, $FORM{'thread_list'});
   @msg_num_list = split(/,/, $FORM{'msg_num_list'});
   $nrest = 0;

   if ($list_type > 1) {
      # restore one or more entire threads
      foreach $thread (@thread_list) {
         $filename = "$basedir/$index2"; $num = 0;
         &remove_from_index;
         foreach $oldname (<$basedir/$dir2/$thread-*.*>) {
            $newname = $oldname;
            $newname =~ s/$basedir\/$dir2\//$basedir\/$msgdir\//;
            rename ($oldname,$newname) or &error ("cannot move $oldname to $newname");
            $nrest++;
            $filename = $newname;
            $filename =~ /$msgdir\/$thread-(\d+)\.\w+/; $num = $1;
            &restore_hidden;
            &find_contents;
            &add_to_uindex;}
         $filename = "$basedir/$msgdir/$thread-1.$ext1"; $num = 1;
         &find_contents;
         &find_followups;  $num_fo = @followups + 1;
         &add_thread_to_main_index;
         foreach $filename (<$basedir/$msgdir/$thread-*.*>) {
            &remove_dead_links;}}
      $threads = join (',',@thread_list);
      &write_log ("$action. Moderator=$moderator, Board=$board, Threads=$threads");}
   else {
      # restore one or more messages in same thread
      $thread = $thread_list[0];
      foreach $msg_num (@msg_num_list) {
         if ($msg_num != 1 and !(-e "$basedir/$msgdir/$thread-1.$ext1")) {
            &error ("Cannot restore message because thread index $thread-1.$ext1 missing");}
         $oldname = "$basedir/$dir2/$thread-$msg_num." . (($msg_num==1)?$ext1:$ext2);
         $newname = $oldname;
         $newname =~ s/$basedir\/$dir2\//$basedir\/$msgdir\//;
         rename ($oldname,$newname) or &error ("cannot move $oldname to $newname");
         $nrest++;
         $filename = "$basedir/$index2"; $num = $msg_num;
         &remove_from_index;
         $filename = $newname;
         &find_contents;
         &add_to_uindex;
         &restore_in_thread_index;
         $filename = "$basedir/$msgdir/$thread-1.$ext1";
         &find_followups;
         $filename = $newname;
         &restore_hidden;
         &remove_dead_links;
         $previous = $fprev; $next = $fnext ? $fnext : -1;
         &change_previous_next;
         if ($fprev) {
            $num = $fprev; $previous = 0; $next = $msg_num;
            &change_previous_next;}
         if ($fnext) {
            $num = $fnext; $previous = $msg_num; $next = 0;
            &change_previous_next;}
         if (@followups) {
            foreach $num (@followups) {
               $filename = "$basedir/$msgdir/$thread-$num.$ext2";
               if (-e $filename) {
                  &restore_hidden;
                  &remove_dead_links;}}}}
      $messages = join (',',@msg_num_list);
      &write_log ("$action. Moderator=$moderator, Board=$board, Thread=$thread, Messages=$messages");}}


sub disk_use {
   # show disk usage
   $dir = $basedir; $forwhat = $board;
   if ($action =~ /all/) {
      $dir =~ s/\/$board\Z//;
      $forwhat = "entire site";}
   $du = `du $dir`;
   $du =~ s/\n/<br>/g;
   print "Content-type: text/html\n\n<html><head>\n";
   print "<title>$board<\/title><\/head>\n";
   print "<body $colors><center><p><font face=\"arial\">\n";
   print "[ <a href=\"$baseurl\/$indexfile\" accesskey='i'>Main <span class='hotkey'>i</span>ndex</a> ]\n";
   print "<h2>Disk use statistics for $forwhat</h2>\n<p>kilobytes:<br>\n";
   print $du;
   print "</font></body>";}

sub feedback_success {
   print "Content-type: text/html\n\n<html><head>\n";
   print "<title>$board<\/title><\/head>\n";
   print "<body $colors>\n<font color=$ecolor face=\"arial\"><p><h1>";
   if ($logo) {
      print "<img align=left src=\"$baseurl/$msgdir/$logo\"> &nbsp;\n";}
   print "$action completed successfully</h1>\n";
   print "</font><center><font face=\"arial\">";
   print "[ <a href=\"$baseurl\/$indexfile\" accesskey='i'>Main <span class='hotkey'>i</span>ndex</a> ]\n";
   if ($action =~ /del/ or $action =~ /purg/) {
      print "[ <a href=\"$baseurl/$dindex\" accesskey='d'><span class='hotkey'>D</span>eleted files index</a> ]\n";}
   if ($action =~ /old/ or $action =~ /purg/) {
      print "[ <a href=\"$baseurl/$oindex\" accesskey='o'><span class='hotkey'>O</span>ld files index</a> ]\n";}
   if ($action =~ /mov/ and $list_type < 2 and $num > 1
   or  $action =~ /rest/ and $list_type < 2) {
      print "[ <a href=\"$baseurl/$msgdir/$thread-1\.$ext1\#i\" accesskey='t'><span class='hotkey'>T</span>hread index</a> ]\n";}
   if ($action =~ /mov/ and $list_type == 0) {
      print "[ <a href=\"$baseurl/$dir2/$thread-$num\." . (($num==1)?$ext1:$ext2) . "\">Moved message</a> ]\n";}
   if ($action =~ /purg/) {
      print "<p>$ndel files deleted\n";}
   if ($action =~ /rest/) {
      print "<p>$nrest files restored\n";}
   if ($action =~ /mov/) {
      print "<p>$nmov files moved\n";}
   print "</font></center></body>";}


###############################################################################
#                      general subroutines
###############################################################################

sub check_permission {
   # check password
   if ($passwordlist{$moderator} ne $passw) {
      &write_log ("Password failure. Moderator=$moderator, Board=$board, $action $threads-$messages");
      &error ("Password not accepted for $moderator");}
   # check if moderator has access to selected board
   if ($boardlist{$moderator} =~ /[\A\s,]*$board[\Z\s,]*/) {return 1;}
   if ($boardlist{$moderator} =~ /[\A\s,]*all[\Z\s,]*/) {return 1;}
   # not accepted
   &write_log ("Permission failure. Moderator=$moderator, Board=$board, $action $threads-$messages");
   if (!$moderator) {
      $errormessage = "Moderator name missing";}
   else {
      $errormessage = "Sorry, $moderator does not have access to $board<br>";
      $errormessage .= "You have access to:<br>$boardlist{$moderator}";}
   &error($errormessage);}

sub make_message_list {
   # makes a list of selected messages or selected threads in @message_list
   while ($threads =~ /(\d+)\s*\.{2,3}\s*(\d+)/) {
      $threads = $` . &number_list($1,$2) . $';}
   while ($messages =~ /(\d+)\s*\.{2,3}\s*(\d+)/) {
      $messages = $` . &number_list($1,$2) . $';}
   @thread_list = sort {$a<=>$b} (split (/,/,$threads));
   @msg_num_list = sort {$a<=>$b} (split (/,/,$messages));
   if (not @thread_list) {
      &error ("Thread(s) not specified");}
   if (@thread_list > 1 && @msg_num_list) {
      &error ("Messages field must be blank if multiple threads specified");}
   if ($threads =~ /([^\d\s,]+)/ or $messages =~ /([^\d\s,]+)/) {
      &error ("Illegal number '$1'");}

   # find which directory messages are in
   $directory = $msgdir;
   if ($action eq 'purgold' or $action eq 'restold') {
      $directory = $olddir;}
   elsif ($action eq 'purgdel' or $action eq 'restdel') {
      $directory = $deletedir;}
   elsif ($action eq 'edit') {
      if (not @msg_num_list) {@msg_num_list = (1);}
      $thread = $thread_list[0]; $num = $msg_num_list[0];
      $filename = "$thread-$num\." . (($num==1) ? $ext1 : $ext2);
      if (not -e "$basedir/$directory/$filename") {
         $directory = $olddir;
         if (not -e "$basedir/$directory/$filename") {
            $directory = $deletedir;
            if (not -e "$basedir/$directory/$filename") {
               &error ("Message $filename not found");}}}}
               
   if (@thread_list == 1 and $msg_num_list[0] == 1) {
      # does the list include all messages in thread?
      $thread = $thread_list[0];
      $filename = "$basedir/$directory/$thread-1.$ext1";
      if (-e $filename) {
         $thread = $thread_list[0]; $num = 1; $missing = 0;
         &find_followups;
         foreach $fo(@followups) {
            if (not grep ($_==$fo,@msg_num_list)) {
               $missing++;}}
         if (!$missing) {
            @msg_num_list = ();}}}

   if ($action eq 'edit' and @thread_list == 1 and not @msg_num_list) {
      @msg_num_list = (1);}

   if (not @msg_num_list) {
      # one or more whole threads
      $list_type = 2;  @list2 = (); $last_ = -1;
      foreach $thread(@thread_list) {
         $filename = "$thread-1\.$ext1";
         if ((-e "$basedir/$directory/$filename") and $thread != $last_) {
            push @list2, $thread; $last_ = $thread;
            push (@message_list, $filename);}}
      @thread_list = @list2;}
   else {
      # one thread
      if (@msg_num_list  > 1) {
         # multiple messages in same thread
         $list_type = 1;}
      else {
         # single message
         $list_type = 0;}
      $thread = $thread_list[0];
      @list2 = (); $last_ = -1;
      foreach $msg(@msg_num_list) {
         $filename = "$thread-$msg\." . (($msg==1) ? $ext1 : $ext2);
         if ((-e "$basedir/$directory/$filename") and $msg != $last_) {
            push @list2, $msg; $last_ = $msg;
            push @message_list, $filename;}}
      @msg_num_list = @list2;}

   if ($action eq 'edit' and $list_type) {
      &error("Cannot edit multiple messages in one operation");}
   if (not @message_list) {
      &error ("Listed message(s) do not exist");}}

sub number_list {
   # make a list of comma-separated numbers. called by make_message_list
   if ($_[0] > $_[1]) {&error ("Wrong range $_[0] .. $_[1]");}
   if ($_[1] - $_[0] >= $maxlistlength) {&error ("List too long: $_[0]..$_[1]");}
   my $list = $_[0];
   for ($i = $_[0]+1; $i <= $_[1]; $i++) {
      $list .= ",$i";}
   return $list;}

sub remove_thread_from_main_index {
   # removes all entries for $thread from main index file
   $filename = "$basedir/$indexfile"; $num = 1;
   &safeopen or &error ("cannot open file $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
      if ($fline =~ /<li><a href=\"$msgdir\/$thread-/) {
         # line found
         $fline = '';}}
   truncate(FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}

sub add_thread_to_main_index {
   # adds entry for $thread to main index file
   $filename = "$basedir/$indexfile"; $num = 1;
   &safeopen or &error ("cannot open file $filename");
   @lines = <FIL>;
   $found = 0;
   foreach $fline (@lines) {
      if ($fline =~ /<!--afmsg-->/) {
         $found = 1;}
      if ($found and
      (($fline =~ /<li><a href=\"$msgdir\/(\d+)-1\./ and $1 <= $thread)
      or $fline =~ /<\/ul>/)) {
         $newline = "<li><a href=\"$msgdir/$thread-1\.$ext1#i\">$num_fo</a> ";
	      $newline .= "<a href=\"$msgdir\/$thread-1\.$ext1\">$subject</a> ";
         $newline .= "by <b>$name</b> posted <i>$fdate</i>\n";
         $fline = $newline . $fline;
         last;}}
   truncate(FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}


sub add_to_index {
   # add an entry $dir2/$thread-$num to an index file $filename (oindex or dindex)
   # with $subject, $name, $fdate, and possibly $reason
   &safeopen or &error ("cannot open file $filename");
   @lines = <FIL>;
   $found = $beg = 0;
   foreach $fline (@lines) {
      if ($fline =~ /<!--afmsg-->/) {
         $beg = 1;}
      if ($beg and (!$found) and (($fline =~ /<\/ul>/) or (
      $fline =~ /<a href=\"$dir2\/(\d+)-(\d+)\.\w+\">/
      and ($1 < $thread or $1 == $thread and $2 <= $num)))) {
         #insert here
         $found = 1;
         if ($list_type > 1) {$size = @followups + 1;} else {$size = 1;}
         $nline = "<li>$size <a href=\"$dir2/$thread-$num\.";
         $nline .= ($num == 1) ? "$ext1\#i\">" : "$ext2\">";
         $nline .= "$subject</a> by <b>$name</b> posted <i>$fdate</i>";
         if ($reason) {
            $nline .= " <font color=$mcolor>$reason</font>";}
         $fline = $nline . "\n" . $fline;}}
   truncate(FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}


sub remove_from_index {
   # remove an entry $dir2/$thread-$num from an index file $filename (oindex or dindex)
   # if $num==0 then remove all entries for thread
   &safeopen or &error ("cannot open file $filename");
   @lines = <FIL>;
   $found = $beg = 0;
   foreach $fline (@lines) {
      if ($fline =~ /<!--afmsg-->/) {
         $beg = 1;}
      if ($beg and $fline =~ /<li>.+<a href=\"$dir2\/$thread-(\d+)\.\w+#?\w*\">/
      and ($1 == $num or $num == 0)) {
         $fline = '';}}
   truncate(FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}


sub remove_from_uindex {
   # removes entry for $thread-$num from the unordered index
   $filename = "$basedir/$uindex";
   &safeopen or &error ("cannot open $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
      if ($fline =~ /<a href=\"$msgdir\/$thread-$num\.\w+\">/) {
         $fline = ''; last;}}
   truncate (FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}
   

sub remove_thread_from_uindex {
   # removes all entries for $thread from the unordered index
   $filename = "$basedir/$uindex";
   &safeopen or &error ("cannot open $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
      if ($fline =~ /<a href=\"$msgdir\/$thread-\d+\.\w+\">/) {
         $fline = '';}}
   truncate (FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}

sub add_to_uindex {
   # restores entry for $thread-$num to the unordered index
   $filename = "$basedir/$uindex";
   &safeopen or &error ("cannot open $filename");
   @lines = <FIL>; $found = 0;
   foreach $fline (@lines) {
      if (($fline =~ /<a href=\"$msgdir\/(\d+)-(\d+)\.\w+\">/
      and ($1 < $thread or $1 == $thread and $2 < $num))
      or ($fline =~ /<hr>/ and $found)) {
         # insert here
         $a = "<a href=\"$msgdir\/$thread-$num\.";
         $b = ($num == 1) ? $ext1 : $ext2;
         $c = "\">$subject</a> <b>$name</b> <i>$fdate</i><br>\n";
         $fline = $a . $b . $c . $fline;
         last;}
      if ($fline =~ /<!--af=\d+-->/) {
         $found = 1;}}
   truncate (FIL,0); seek (FIL,0,0); 
   print(FIL @lines); &safeclose;}

sub remove_from_thread_index {
   # removes entry for $num from thread index $filename
   &safeopen or &error ("remove_from_thread_index: Cannot open $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
      if ($fline =~ /<li><a href=\"$thread-$num\.$ext2\">(.*)<\/a>.*<b>(.*)<\/b>.*<i>(.*)<\/i>/ ) {
         $fline = "<!-- removed \t$thread-$num.$ext2\t$1\t$2\t$3\t-->\n";}}
   truncate (FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}

sub restore_in_thread_index {
   # restores removed entry for $num in the thread index
   $filename = "$basedir/$msgdir/$thread-1.$ext1";
   &safeopen or &error ("restore_in_thread_index: cannot open $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
      if ($fline =~ /<!-- removed \t$thread-$num\.$ext2\t(.*)\t(.*)\t(.*)\t-->/ ) {
         $fline = "<li><a href=\"$thread-$num.$ext2\">$1</a> by <b>$2</b> posted <i>$3</i>\n";}}
   truncate (FIL,0); seek (FIL,0,0);      
   print(FIL @lines); &safeclose;}

sub find_contents {
   # finds $subject, $name, $fdate, $previous, $next, $followupto
   # from a message $filename
   open FIL, "$filename" or &error ("find_contents: Cannot open $filename");
   @lines = <FIL>; close FIL;
   $subject = ''; $name = ''; $fdate = ''; $previous = ''; $next = ''; $followupto = '';
   foreach $fline (@lines) {
      if (!$subject and $fline =~ /(.*)<\/h1>/) {
         $subject = $1;}
      if (!$name and ($fline =~ /Posted by( ?)<b>(.*)<\/b> on <i>(.*) (.*)<\/i>/ or
      $fline =~ /Posted by <a href(.*)>(.*)<\/a> on <i>(.*) (.*)<\/i>/)) {
         $name = $2;  $fdate = $3;}
      if (!$previous and $fline =~ /\[ <a href=\"(\d+)-(\d+)\.(\w+)\".*>.*revious message<\/a> \]/) {
         $previous = $2;}
      if (!$next and $fline =~ /\[ <a href=\"(\d+)-(\d+)\.(\w+)\".*>.*ext message<\/a> \]/) {
         $next = $2;}
      if (!$followupto and $fline =~ /In Reply to: <a href=\"(\d+)-(\d+)\.(\w+)\">/) {
         $followupto = $2;}}}

sub change_links {
   # change cross-links in a message $num to remove all references to $msg_num
   $filename = "$basedir/$msgdir/$thread-$num." . (($num==1) ? $ext1 : $ext2);
   &safeopen or return;
   @lines = <FIL>;
   foreach $fline (@lines) {
      if ($fline =~ /<a href=\"$thread-$msg_num\.\w+\".*>(.*)<\/a>/) {
         # cross link to $msg_num found
         if ($1 =~ /revious/i) {
            if ($previous) {
               $fline = "[ <a href=\"$thread-$previous." . (($previous==1) ? $ext1 : $ext2);
               $fline .= "\" accesskey='p'><span class='hotkey'>P</span>revious message</a> ]\n";}
            else {
               $fline = '';}}
         elsif ($1 =~ /Next/i) {
            if ($next) {
               $fline = "[ <a href=\"$thread-$next.$ext2\" accesskey='n'><span class='hotkey'>N</span>ext message</a> ]\n";}
            else {
               $fline = "<!--next-->\n";}}
         elsif ($fline =~ /In Reply to: /) {
            $fline =~ s/In Reply to: <a href(.*)<\/a>/In Reply to removed message: <u><!a href$1<\/u>/i;}}}
   truncate (FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}

sub change_previous_next {
   # change cross-links in a message $thread-$num
   # link to previous changed to $previous
   # link to next changed to $next
   # 0 = leave unchanged, -1 = remove link
   $filename = "$basedir/$msgdir/$thread-$num." . (($num==1) ? $ext1 : $ext2);
   &safeopen or &error("change_previous_next cannot open $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
      if ($fline =~ /<!?a href=\"$thread-(\d+)\.\w+\".*>(.*)<\/a>/ or $fline =~ /<!--next-->/) {
         # cross link found
         if ($2 =~ /revious/i) {
            if ($previous > 0) {
               $fline = "[ <a href=\"$thread-$previous." . (($previous==1) ? $ext1 : $ext2);
               $fline .= "\" accesskey='p'><span class='hotkey'>P</span>revious message</a> ]\n";}}
         elsif ($2 =~ /ext/i or $fline =~ /<!--next-->/) {
            if ($next > 0) {
               $fline = "[ <a href=\"$thread-$next.$ext2\" accesskey='n'><span class='hotkey'>N</span>ext message</a> ]\n";}
            elsif ($next == -1) {
               $fline = "<!--next-->\n";}}}}
   truncate (FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}


sub hide_button {
   # hide button "Submit Follow Up" from message $filename
   # and remove link to thread index
   &safeopen or &error ("hide_button: Cannot open $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
      $fline =~ s/<input type=submit value=\"Submit Follow Up\".*>/<!--submit button-->/;
      $fline =~ s/<a( href=\"\d+-1\.\w+\#i\">Thread index<\/a>)/<!a$1/;}
   truncate(FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}

sub hide_links {
   # hide links to "previous", "next", "in reply to" from message $filename
   &safeopen or &error ("hide_links: Cannot open $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
      $fline =~ s/\[ <a( href="\d+-\d+\.\w+\">)(Previous|Next)( message<\/a> \])/\[ <!a$1$2$3/;
      $fline =~ s/In Reply to: <a (href=\"\d+-\d+\.\w+\">)/In Reply to: <!a $1/;}
   truncate(FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}

sub restore_hidden {
   # restore hidden links and button in message $filename
   &safeopen or &error ("restore_hidden: Cannot open $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
      $fline =~ s/<!--submit button-->/<input type=submit value='Submit Follow Up' accesskey='s'>/;
      $fline =~ s/<!(\ ?)a href=\"/<a href=\"/;
      if ($fline =~ /In Reply to removed message: <u>(.*)<\/u>(.*)/) {
         $fline = "In Reply to: $1</a>$2\n";}}
   truncate(FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}

sub remove_dead_links {
   # remove dead links in file $filename
   &safeopen or &error ("remove_dead_links: Cannot open $filename");
   @lines = <FIL>;
   foreach $fline (@lines) {
     if ($fline =~ /<a href=\"([^\"]+)\".*>/ ) {
        $link = $1;
        if ($link =~ /http:/ or $link =~ /\.\.\//
        or $link =~ /\A\// or $link =~ /\#/) {
           next;}
        if (not (-e "$basedir/$msgdir/$link")) {
           if ($fline =~ />ext message</i) {
              $fline = "<!--next-->\n";}
           else {
              $fline =~ s/<a href=\"/<!a href=\"/;}}}}
   truncate(FIL,0); seek (FIL,0,0);
   print(FIL @lines); &safeclose;}


sub find_followups {
   # makes a list of follow-ups to a given message $thread-$num
   # input $filename = thread index
   # outputs list @followups and date of last follow-up $last_fo_date
   # also finds previous and next $fprev, $fnext
   open FIL, "$filename" or &error ("find_followups: cannot open $filename");
   @lines = <FIL>; close FIL;
   $found_index = $found_num = $fprev = $fnext = 0;
   @followups = ();
   foreach $fline (@lines) {
      if ($fline =~ /<!--aflast=\d+-->/) {
         $found_index = 1;}
      if ($found_index and $fline =~ /<a href=\"$thread-(\d+)\.\w+\">.*<i>(\d{4}-\d+-\d+)<\/i>/) {
         if ($found_num == 0 and $1 == $num) {
            $found_num = 1;}
         if ($found_num == 1 and $1 > $num) { 
            push (@followups, $1);
            if ($2 ge $last_fo_date) {
               $last_fo_date = $2; $last_fo_thread = $thread; $last_fo_num = $1;}}
         if ($found_num == 0) {
            $fprev = $1;}
         if ($found_num and $1 != $num and $fnext == 0) {
            $fnext = $1;}}
      if ($found_num and $fline =~ /<!--af$num(L?)-->/) {
         $found_num = 2;}}}
                                      

# open file for exclusive access
sub safeopen {
   open FIL, "+<$filename" or return 0;
   $n = 0;
   while (!flock(FIL,2)) {
      $n++;
      if ($n > 10) {
         # timeout
         return 0;}
      sleep (4);}
   return 1;}

sub safeclose {
   flock (FIL,8);
   close FIL;}

sub error {
   $error = $_[0];
   print "Content-type: text/html\n\n<html><head>\n";
   print "<title>Message board error<\/title><\/head>\n";
   print "<body $colors>\n<font color=$ecolor><p><h1>";
   if ($logo and $board) {
      print "<img align=left src=\"$baseurl/$msgdir/$logo\"> &nbsp;\n";}
   print "Error</h1><h2 align=center>$error</h2>\n</font></body>";
   exit;}

sub write_log {
   open (FIL, ">>$logfile");
   print (FIL "$date_time: $_[0]\n");
   close (FIL);}

