#!/usr/bin/perl
##############################################################################
# Web message Board                    Last Modified 1999-11-02 by Agner Fog #
#                                                                            #
# Please see readme.txt for instructions                                     #
##############################################################################
# Define filenames, directories
         
$ext1 = 'shtml';    # extension for index files
$ext2 = 'htm';      # extension for other files

$basedir = '..';
$baseurl = '..';
$_ = $0; s/.*\///;
$cgi_url = "/cgi-bin/$_";
$msgdir  = 'messages';     # subdirectory for messages
$backupdir = 'old';        # subdirectory for backup
$tnumfile = 't.dat';       # file counting threads
$indexfile = "index.$ext1";
$uindex = "uindex.$ext1";
$faqfile = "faq.$ext2";
$style_sheet = 's.css';    # blank if no style sheet
$logo = 'm.gif';    # logo image
$errorlog = '~/error.log';

# Define Options
#colors of text, background and links:
$colors = 'text="#000000" bgcolor="#D0FFFF" link="#0000E0" vlink="#E000E0"';
$dcolor = '#000080';  # color of feedback dialog
$ecolor = '#FF0000';  # color of error messages
$prevbgr = '#B0FFB0'; # background color of preview
$show_faq = 1;	       # make link to FAQ
$preview_links = 0;   # show links in preview
$allow_html = 1;      # allow HTML codes
$gmt = 1;	          # use Greenwich Mean Time
$maxuindex = 250;     # max number of entries in unthreaded index
$maxsize = 30000;     # max message size in bytes

###########################################################################

# Get Form Information
&parse_form;

# Put items into nice variables
&get_variables;   

if ($command eq 'makeform') {
   # First call: Make form for entering or re-editing message
   &check_space;
   &get_num;
   &make_form;}

elsif ($command eq 'review') {
   # Second call: show message to user for review and accept
   &make_preview;}

elsif ($command eq 'submit') {
   # Third call: Text has been approved by user
   if (-e ("$basedir/$msgdir/$thread-$num\." . ($followupto ? $ext2 : $ext1))) {
      &error("This message has already been posted");}

   if ($followupto) {
      &new_fo;
      &new_file;}
   else {
      &new_file;
      &new_thread;}
   &return_success;}
else {
   &error ('Wrong command');}


# Parse Form Subroutine
sub parse_form {
   # Get the input
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

   # Split the name-value pairs
   @pairs = split(/&/, $buffer);  $buffer = "";

   foreach $pair (@pairs) {
      ($nam, $value) = split(/=/, $pair);

      # Un-Webify plus signs and %-encoding
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/eg;
      $value =~ s/<!(.|\n)*?>//g;

      if (! $allow_html or $nam ne 'body') {
         $value =~ s/<(.|\n)*?>//g;}
      $FORM{$nam} = $value;}}

sub get_variables {
   $command = $FORM{'command'};
   if (not $command) {
      $baseurl .= "test";
      if ($board) {
         &error('Transmission error. Please press Back button and try again.');}
      else {
         &error ('Board script called without command');}}
   if ($command eq 'submit' and $FORM{'command2'} =~ /edit/i) {
      $command = 'makeform';} #user pressed 'Edit message again'
   $board = $FORM{'board'};
   if (not $board) {
      $baseurl .= "test";
      &error ('Board name missing');}
   $basedir .= "/$board";
   $baseurl .= "/$board";
   $thread = $FORM{'thread'};
   $num = $FORM{'num'};
   $title = $FORM{'title'};

   $followupto = $FORM{'followupto'};
   if ($followupto) {
      $origdate = "$FORM{'origdate'}";
      $origname = "$FORM{'origname'}";
      $origsubject = "$FORM{'origsubject'}";}
   if ($FORM{'name'}) {
      $name = "$FORM{'name'}";
      $name =~ s/"//g;
      $name =~ s/<//g;
      $name =~ s/>//g;
      $name =~ s/\&//g;}
   if ($FORM{'email'} =~ /.*\@.*\..*/) {
      $email = "$FORM{'email'}";}

   if ($FORM{'subject'}) {
      $subject = "$FORM{'subject'}";
      $subject =~ s/\&/\&amp\;/g;
      $subject =~ s/"/\&quot\;/g;}

   if ($FORM{'url'} =~ /\./) {
      $message_url = "$FORM{'url'}";
      if ($message_url !~ /:/ and $message_url !~ /^\d+-1\.$ext1/ and $message_url !~ /^\d+-\d+\.$ext2/) {
         $message_url = 'http://' . $message_url;}
      $message_url_title = "$FORM{'url_title'}";
      if (not $message_url_title) {
         $message_url_title = $message_url;}}

   if ($FORM{'img'} =~ /\..*\//) {
      $img = "$FORM{'img'}";
      if ($img !~ /tp:\/\//) {
         $img = 'http://' . $img;}}

   $body1 = $FORM{'body'};  $FORM{'body'} = "";
   if ($body1) {
      $body1 =~ s/\r\n/\n/g; # translate \r
      $body1 =~ s/\n\r/\n/g;
      $body1 =~ s/\r/\n/g;
      $body1 =~ s/<form(.|\n)*?>//gi; # remove illegal html codes
      $body1 =~ s/<script(.|\n)*?>//gi;
      $body1 =~ s/<applet(.|\n)*?>//gi;
      $body1 =~ s/<input(.|\n)*?>//gi;
      $body1 =~ s/<object(.|\n)*?>//gi;
      $body1 =~ s/<param(.|\n)*?>//gi;
      $body1 =~ s/<server(.|\n)*?>//gi; 
      if (length($body1) > $maxsize) {
         $truncated = 1; # limit text size
         $body1 = substr($body1,0,$maxsize);}
      if ($body1 =~ /<p>/i || $body1 =~ /<p\s.*>/i || $body1 =~ /<br\s*\/?>/i) {
         $nolinefeeds = 1;} # don't make automatic linefeeds
      $body1 =~ s/<head(.|\n)*<\/head>//ig; #remove <head>, <body>
      $body1 =~ s/<\/?body(.|\n)*?>//ig;

      $body2 = $body1;
      $body1 =~ s/</&lt;/g;
      $body1 =~ s/>/&gt;/g;
      $body1 =~ s/"/&quot;/g;

      $body2 =~ s/&lt;/</g; $body2 =~ s/&gt;/>/g; $body2 =~ s/&quot;/"/g;
      $body2 =~ s/(\n?)<bq>(\n?)/<BLOCKQUOTE>/gi; # translate user code
      $body2 =~ s/(\n?)<\/bq>(\n?)/<\/BLOCKQUOTE>/gi;
      if ($nolinefeeds) {
         $body2 =~ s/<\/?html.*?>//ig;}
      else { # translate linefeeds
         $body2 =~ s/\n\n/<p>/g;  $body2 =~ s/\n/<br>/g;}}

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = $gmt ? gmtime(time) : localtime(time);
   if ($sec < 10) {$sec = "0$sec";}
   if ($min < 10) {$min = "0$min";}
   if ($hour < 10) {$hour = "0$hour";}
   if ($mday < 10) {$mday = "0$mday";}
   $mon++;
   if ($mon < 10) {$mon = "0$mon";}
   $year += 1900;
   $date = "$year-$mon-$mday";
   $date_time = "$date $hour\:$min\:$sec";
}

sub new_file {
   # make new message file
   $filename = "$basedir/$msgdir/$thread-$num\." . ($followupto ? $ext2 : $ext1);
   open(NEWFILE,">$filename") or &error ("Cannot create file $filename");
   $lines = "<html><head>";
   if ($style_sheet) {
      $lines .= "<link rel=stylesheet href=\"$style_sheet\" type=\"text/css\">\n";}
   $lines .=  "<title>$title</title></head><body $colors><h1>\n";
   if ($logo) {$lines .=  "<img align=left src='$logo' alt='logo'> &nbsp;\n";}
   $lines .=  "$subject</h1><center>\n";
   if ($followupto) {
      $lines .=  "[ <a href=\"$thread-1\.$ext1#i\" accesskey='t' rel='start'><span class='hotkey'>T</span>hread index</a> ]\n";}
   else {
      $lines .=  "[ <a href=\"#i\">Thread index</a> ]\n";}
   $lines .=  "[ <a href=\"$baseurl\/$indexfile\" accesskey='i' rel='index'>Main <span class='hotkey'>i</span>ndex</a> ]\n";
   if ($followupto) {
      $ext = ($previous == 1) ? $ext1 : $ext2;
      $lines .=  "[ <a href=\"$thread-$previous\.$ext\" accesskey='p' rev='previous'><span class='hotkey'>P</span>revious message</a> ]\n";
      if ($next) {
         $lines .=  "[ <a href=\"$thread-$next\.$ext2\" accesskey='n' rel='next'><span class='hotkey'>N</span>ext message</a> ]\n";}
      else {
         $lines .=  "<!--next-->\n";}}
   else {
      $lines .=  "<!--next-->\n";}
   if ($show_faq) {
      $lines .=  " [ <a href=\"../$faqfile\" accesskey='f' rel='help'><span class='hotkey'>F</span>AQ</a> ]";}
   $lines .=  "</center><hr><p>\nPosted by ";
   if ($email) {
      $lines .=  "<a href=\"mailto:$email\">$name</a> on <i>$date_time</i><p>\n";}
   else {
      $lines .=  "<b>$name</b> on <i>$date_time</i><p>\n";}
   if ($followupto) {
      $ext = ($followupto == 1) ? $ext1 : $ext2;
      $lines .=  "In Reply to: <a href=\"$thread-$followupto\.$ext\">$origsubject</a> posted by ";
      $lines .=  "<b>$origname</b> on <i>$origdate</i>\.<p>\n";}
   if ($img) {
      $lines .=  "<center><img src=\"$img\" alt='User-supplied image'></center><p>\n";}

   $lines .=  "$body2\n<p>";
   if ($message_url) {
      $lines .=  "<ul><li><a href=\"$message_url\">$message_url_title</a></ul>\n";}

   $lines .=  "<br><hr><p>\n";
   $lines .=  "<form method=POST action=\"$cgi_url\">\n";
   $lines .=  "<input type='hidden' name=\"board\" value=\"$board\">";
   $lines .=  "<input type='hidden' name=\"title\" value=\"$title\">";
   $lines .=  "<input type='hidden' name=\"command\" value=\"makeform\">";
   $lines .=  "<input type='hidden' name=\"thread\" value=\"$thread\">";
   $lines .=  "<input type='hidden' name=\"followupto\" value=\"$num\">";
   $lines .=  "<input type='hidden' name=\"origname\" value=\"$name\">\n";
   $lines .=  "<input type='hidden' name=\"origsubject\" value=\"$subject\">\n";
   $lines .=  "<input type='hidden' name=\"origdate\" value=\"$date\">\n";
   $lines .=  "<input type=submit value=\"Submit Follow Up\" accesskey='s'>";
   $lines .=  "</form>\n";
   if (not $followupto) {
      $lines .=  "<!--aflast=1-->\n";
      $lines .=  "<b><a name=\"i\">Thread index:</a></b><p>\n";
      $lines .=  "<a href=\"$thread-1\.$ext1\">$subject</a> by <b>$name</b> posted <i>$date</i>\n";
      $lines .=  "<!--af1-->\n<p>";}
   $lines .=  "</body></html>\n";
   print NEWFILE $lines;
   $n = 0;
   while (! close NEWFILE) {
      if ($n++ > 10) {
         &error ("Cannot close $filename.");}
      sleep (3);}

   # update unthreaded index
   $filename = "$basedir/$uindex";
   if (&safeopen) {
      @lines = <FIL>;
      truncate (FIL,0); seek (FIL,0,0);
      $total = 0; $listed=0;
      foreach $fline (@lines) {
         if (!$total) {
            if ($fline =~ /<!--af=(\d+)-->/) {
               # increment thread number
               $total=$1+1; $fline = "<!--af=$total-->\n";
               # insert new message
               $ext = ($num == 1) ? $ext1 : $ext2;
               $fline .= "<a href=\"$msgdir/$thread-$num\.$ext\">$subject</a> <b>$name</b> <i>$date_time</i><br>\n";
               $listed++;}}
         elsif ($fline =~ /\A<a href/) {
            $listed++;}
         else {
            last;}
         if ($listed > $maxuindex) {
            last;}
         else {
            print FIL $fline;}}
      print FIL "<hr>Total number of messages posted = $total.";
      if ($listed > $maxuindex) {
         print FIL "<p>Only last $maxuindex messages shown.";}
      print FIL "\n</body></html>";
      &safeclose;}}


sub make_form {
   # make message entry form
   print "Content-type: text/html\n\n<html><head>\n";
   if ($style_sheet) {
      print "<link rel=stylesheet href=\"$style_sheet\" type=\"text/css\">\n";}
   print "<title>$title</title></head>\n<body $colors>\n<font color=$dcolor><h1>";
   if ($logo) {
      print "<img align=left src='$baseurl/$msgdir/$logo' alt='logo'> &nbsp;\n";}
   print $followupto ? "Post followup message" : "Post message - new thread";
   print "</h1><p>";
   if ($show_faq) {
      print "<center>Please read the <a href=\"$baseurl/$faqfile\" accesskey='f' rel='help'><span class='hotkey'>F</span>AQ</a> before posting a message.</center><p>";}
   print "<hr>\n<form method=POST action=\"$cgi_url\">\n";
   print "<input type='hidden' name=\"board\" value=\"$board\">\n";
   print "<input type='hidden' name=\"thread\" value=\"$thread\">\n";
   print "<input type='hidden' name=\"num\" value=\"$num\">\n";
   print "<input type='hidden' name=\"title\" value=\"$title\">\n";
   if ($followupto) {
      print "<input type='hidden' name=\"followupto\" value=\"$followupto\">\n";
      print "<input type='hidden' name=\"origsubject\" value=\"$origsubject\">\n";
      print "<input type='hidden' name=\"origname\" value=\"$origname\">\n";
      print "<input type='hidden' name=\"origdate\" value=\"$origdate\">\n";}
   print "<label for='name'><span class='hotkey'>N</span>ame:</label><br> <input type='text' name='name' id='name' size='50' maxlength='100' value=\"$name\" accesskey='n'><br>\n";
   print "<label for='email'><span class='hotkey'>E</span>-Mail:</label><br> <input type='text' name='email' id='email' size='50' maxlength='50' value=\"$email\" accesskey='e'><br>\n";
   if (!$subject) {$subject = $origsubject;}
   print "<label for='subject'><span class='hotkey'>S</span>ubject:</label><br> <input type='text' name='subject' id='subject' value=\"$subject\" size='50' maxlength='100' accesskey='s'><p>\n";
   print "<label for='body'><span class='hotkey'>M</span>essage:</label><br><textarea name='body' id='body' COLS='60' ROWS='20' wrap='virtual' accesskey='m'>";
   $body2 = $body1;
   $body2 =~ s/&lt;/</g; $body2 =~ s/&gt;/>/g; $body2 =~ s/&quot;/"/g;
   print "$body2</textarea><p>\n";
   print "<label for='url'>Optional <span class='hotkey'>L</span>ink URL:</label><br> <input type='text' name='url' id='url' size='50' maxlength='200' value=\"$message_url\" accesskey='l'><br>\n";
   print "<label for='url_title'>Link <span class='hotkey'>T</span>itle:</label><br> <input type='text' name='url_title' id='url_title' size='50' maxlength='100' value=\"$message_url_title\" accesskey='t'><br>\n";
   print "<label for ='img'>Optional Image <span class='hotkey'>U</span>RL:</label><br> <input type='text' name='img' id='img' size='50' maxlength='100' value=\"$img\" accesskey='u'><p>\n";
   print "<input type='hidden' name='command' value='review'>\n";
   print "<input type='submit' value=' OK ' accesskey='o'> &nbsp; <input type='reset' value='Reset' accesskey='r'> &nbsp; ";
   print "<input type='button' value='Cancel' onClick='history.go(-1)' accesskey='c'>";
   print "</form><p><hr><p>\n</font>";
   print "</body></html>\n";}


sub make_preview {
   # make message preview
   print "Content-type: text/html\n\n<html lang='en'><head>\n";
   if ($style_sheet) {
      print "<link rel=stylesheet href=\"$style_sheet\" type=\"text/css\">\n";}
   print "<title>$title<\/title><\/head>\n";
   $colors=~ s/bgcolor=[^ ]+/bgcolor=$prevbgr/;
   print "<body $colors>\n";
   if (not ($name && $subject && $body2)) {
      # error message:
      print "<font color=$ecolor><h1>Message Error\:</h1><p><ul>\n";
      if (not $name) {print "<li>Name missing";}
      if (not $subject) {print "<li>Subject missing";}
      if (not $body2) {print "<li>Message missing";}
      print "</ul></font><font color=$dcolor><p>Please press back button to edit your message again\.\n";}
   else {
      # no error. Print 'Post message' form:
      print "<center><font color=$dcolor><h1>Message preview</h1>\n<p>";
      if ($truncated) {
         print "<font color=$ecolor><h2>Your message is too long. Has been truncated</h2></font><p><font color=$dcolor>";}
      print "Your message will look as shown below.<br>";
      print "Please check it for errors before you press the 'Post Message' button.<p>\n";
      print "<form method=POST action=\"$cgi_url\">\n";
      print "<input type=submit value='Post Message' accesskey='p'> &nbsp;\n";
      print "<input type=submit value='Edit message again' name=\"command2\" accesskey='e'> &nbsp;\n";
      print "<input type=button value='Discard message' onClick='history.go(-2)' accesskey='d'>\n";
      print "<input type='hidden' name=\"board\" value=\"$board\">\n";
      print "<input type='hidden' name=\"thread\" value=\"$thread\">\n";
      print "<input type='hidden' name=\"num\" value=\"$num\">\n";
      print "<input type='hidden' name=\"title\" value=\"$title\">\n";
      print "<input type='hidden' name=\"name\" value=\"$name\">\n";
      print "<input type='hidden' name=\"email\" value=\"$FORM{'email'}\">\n";
      print "<input type='hidden' name=\"subject\" value=\"$subject\">\n";
      print "<input type='hidden' name=\"url\" value=\"$message_url\">\n";
      print "<input type='hidden' name=\"url_title\" value=\"$message_url_title\">\n";
      print "<input type='hidden' name=\"img\" value=\"$img\">\n";
      if ($followupto) {
         print "<input type='hidden' name=\"followupto\" value=\"$followupto\">\n";
         print "<input type='hidden' name=\"origsubject\" value=\"$FORM{'origsubject'}\">\n";
         print "<input type='hidden' name=\"origname\" value=\"$FORM{'origname'}\">\n";
         print "<input type='hidden' name=\"origdate\" value=\"$FORM{'origdate'}\">\n";}
      print "<input type='hidden' name=\"body\" value=\"$body1\">\n";
      print "<input type='hidden' name=\"command\" value=\"submit\"></form>\n";

      print "</center></font><font color=$dcolor><p>\n<hr size=8 width=90%><h1>";
      if ($logo) {
         print "<img align=left src='$baseurl/$msgdir/$logo' alt='logo'> &nbsp;\n";}
      print "$subject</h1><hr>\n";
      if ($preview_links) {
         print "<center>[ <u>Thread index</u> ] [ <a href=\"$baseurl\/$indexfile\" accesskey='i' rel='index'>Main <span class='hotkey'>i</span>ndex</a> ]";
         if ($followupto) {
            print " [ <u>Previous message</u> ] [ <u>Next message</u> ]";}
         if ($show_faq) {
            print " [ <a href=\"$baseurl/$faqfile\" accesskey='f' rel='help'><span class='hotkey'>F</span>AQ</a> ]";}
         print "</center><p><hr>\n";}
      print "<p>Posted by ";
      if ($email) {
         print "<a href=\"mailto:$email\">$name</a> on <i>$date_time</i><p>\n";}
      else {
         print "<b>$name</b> on <i>$date_time</i><p>\n";}
      if ($followupto) {
         $ext = ($followupto == 1) ? $ext1 : $ext2;
         print "In Reply to: <a href=\"$baseurl/$msgdir/$thread-$followupto\.$ext\">$origsubject</a> posted by ";
         print "<b>$origname</b> on <i>$origdate</i>\.<p>\n";}
      if ($img) {
         print "<center><img src=\"$img\" alt='User-supplied image'></center><p>\n";}
      print "<p>\n$body2\n<hr>\n";
      if ($message_url) {
         print "<ul><li><a href=\"$message_url\">$message_url_title</a></ul><hr>\n";}


      }
   print "</font></body></html>\n";}

sub return_success {
   # feedback after posting message
   print "Content-type: text/html\n\n";
   print "<html lang='en'><head>\n<title>$title<\/title>\n";
   if ($style_sheet) {
      print "<link rel=stylesheet href=\"$style_sheet\" type=\"text/css\">\n";}
   $colors=~ s/bgcolor=[^ ]*/bgcolor=$prevbgr/;
   print "</head><body $colors>\n<font color=$dcolor><h2>";
   if ($logo) {
      print "<img align=left src='$baseurl/$msgdir/$logo' alt='logo'> &nbsp;\n";}
   print "Your message has been added successfully</h2><hr>\n";
   $ext = ($num == 1) ? $ext1 : $ext2;
   print "<p align=center>[ <a href=\"$baseurl/$msgdir/$thread-$num\.$ext\" accesskey='y' rel='next'><span class='hotkey'>Y</span>our message</a> ] ";
   print "[ <a href=\"$baseurl/$msgdir/$thread-1\.$ext1#i\" accesskey='t' rel='start'><span class='hotkey'>T</span>hread index</a> ] ";
   print "[ <a href=\"$baseurl/$indexfile\" accesskey='i' rel='index'>Main <span class='hotkey'>i</span>ndex</a> ] ";
   if ($show_faq) {
      print "[ <a href=\"$baseurl\/$faqfile\" accesskey='f' rel='help'><span class='hotkey'>F</span>AQ</a> ]";}
   print "</font></body></html>\n";}


# Add new thread to main index
sub new_thread {
   if (open FIL, "$basedir/$tnumfile") {
      $_ = <FIL>; close FIL;
      if ($thread > $_) {&error("Wrong message number");}}

   $filename = "$basedir/$indexfile";
   &safeopen or &error ("cannot open file $filename");
   @lines = <FIL>; seek (FIL,0,0);

   foreach $fline (@lines) {
      if ($fline =~ /<!--af=(\d+)-->/) {
         # need backup?
         if ($1 != $mday) {$backup = $mday;}
         $fline = "<!--af=$mday-->\n";}
      elsif ($fline =~ /<!--afmsg-->/) {
         # insert link to new thread here
	      $mfound++;
         $fline .= "<li><a href=\"$msgdir/$thread-1\.$ext1#i\">1</a> ";
	      $fline .= "<a href=\"$msgdir\/$thread-1\.$ext1\">$subject</a> ";
         $fline .= "by <b>$name</b> posted <i>$date</i>\n";}}
   print(FIL @lines); &safeclose;
   if ($mfound != 1) {&error ('Main index file corrupted');}

   # make backup of main index
   if ($backup) {
      if (open(FIL,">$basedir/$backupdir/backup$backup\.$ext2")) {
         print(FIL @lines);  close(FIL);}}
}

sub new_fo {
   # Add new followup to thread index
   $filename = "$basedir\/$msgdir\/$thread-1\.$ext1";
   &safeopen or &error ("cannot open file $filename");
   @lines = <FIL>; seek (FIL,0,0);
   $mfound = 0; $previous = 0; $next = 0; $nt = 2;

   foreach $fline (@lines) {
      if ($fline =~ /<!--aflast=(\d+)-->/) {
         # check followup number
         if ($num > $1) {
            &safeclose;
            &error("wrong message number");}}
      elsif ($fline =~ /<!--af$followupto(L?)-->/) {
         # insert link to new followup here
         $mfound++;
         if ($1 eq 'L') {
            $fline = '';}
         else {
            $fline = "<ul>\n";}
         $fline .= "<li><a href=\"$thread-$num\.$ext2\">$subject</a> by <b>$name</b> posted <i>$date</i>\n";
         $fline .= "<!--af$num-->\n";
         $fline .= "<!--af$followupto" . "L-->\n";
         if ($1 ne 'L') {
            $fline .= "</ul>\n";}}
      else {
         # search for previous and next
         if ($fline =~ /<li><a href=\"$thread-(\d+)\./) {
            $nt++;
            # get $previous or $next
            if (! $mfound) {
               $previous = $1;}
            elsif ($previous and ! $next) {
               $next = $1;}}}}
   print(FIL @lines); &safeclose;
   if ($mfound != 1) {
      &error ("Thread index file $thread-1\.$ext1 corrupted");}

   # update thread entry in main index
   $filename = "$basedir/$indexfile";
   if (&safeopen) {
      @lines = <FIL>; truncate (FIL,0); seek (FIL,0,0);
      foreach $fline (@lines) {
         if ($fline =~ /<li><a href=\"$msgdir\/$thread-1\.$ext1#i\">\d+(.*?)<\/i>/) {
            $fline = "<li><a href=\"$msgdir/$thread-1\.$ext1#i\">$nt$1</i>";
            $fline .= " - <i>$date</i>\n";
            last;}}
      print(FIL @lines); &safeclose;}

   # update links in previous
   if (!$previous) {$previous = 1;}
   $ext = ($previous == 1) ? $ext1 : $ext2;
   $filename = "$basedir/$msgdir/$thread-$previous\.$ext";
   if (&safeopen) {
      @lines = <FIL>;
      foreach $fline (@lines) {
         if ($fline =~ /<a href(.*)N.*ext message<\/a>/ or $fline =~ /<!--next-->/) {
            $fline = " [ <a href=\"$thread-$num\.$ext2\" accesskey='n' rel='next'><span class='hotkey'>N</span>ext message</a> ]\n";}}
      truncate (FIL,0); seek (FIL,0,0);
      print(FIL @lines); &safeclose;}

   # update links in next
   if ($next) {
      $filename = "$basedir/$msgdir/$thread-$next\.$ext2";
      if (&safeopen) {
         @lines = <FIL>;
         foreach $fline (@lines) {
            if ($fline =~ /<a href(.*)P.*revious message<\/a>/) {
               $fline = " [ <a href=\"$thread-$num\.$ext2\" accesskey='p' rev='previous'><span class='hotkey'>P</span>revious message</a> ]\n";}}
         truncate (FIL,0); seek (FIL,0,0);
         print(FIL @lines); &safeclose;}}
}

sub get_num {
   # get unique number for new message
   if ($followupto) {
      if ($num) {return;}
      $filename = "$basedir\/$msgdir\/$thread-1\.$ext1";
      &safeopen or &error ("cannot open file $filename");
      @lines = <FIL>; seek (FIL,0,0); $tfound = 0;
      foreach $fline (@lines) {
         if ($fline =~ /<!--aflast=(\d+)-->/) {
            # increment followup number
            $num = $1 + 1; $tfound = 1;
            $fline = "<!--aflast=$num-->\n";
            last;}}
      print(FIL @lines); &safeclose;
      if (!$tfound) {&error ("Thread index $filename corrupted");}}
   else {
      # new thread number
      if ($thread) {return;}
      $filename = "$basedir/$tnumfile";
      &safeopen or &error ("cannot open file $filename");
      $thread = <FIL> + 1;
      seek (FIL,0,0);
      print FIL $thread;
      &safeclose; $num = 1;}}

# open file for exclusive access
sub safeopen {
   open FIL, "+<$filename" or return 0;
   $n = 0;
   while (!flock(FIL,2)) {
      $n++;
      if ($n > 10) {
         # timeout
         return 0;}
      sleep (4);}
   return 1;}

sub safeclose {
   flock (FIL,8); $n = 0;
   while ((! close FIL) and $n++ < 20) {sleep(2);}}
      
sub check_space {
   # check for disk free space
   # IMPORTANT: this function depends on operating system. must be changed if not UNIX/LINUX
   $_ = `df $basedir`;
   /(.|\n)*\s+(\d+)\%/;
   if ($2 > 98) {&error ('System error: Disk full<p>Please try again another day.');}}

sub error {
   $error = $_[0];
   print "Content-type: text/html\n\n<html lang='en'><head>\n";
   # if ($style_sheet) {
   #    print "<link rel=stylesheet href=\"$style_sheet\" type=\"text/css\">\n";}
   print "<title>Message board error<\/title><\/head>\n";
   print "<body $colors><font face=\"arial\">\n<p align = center>";
   if ($board) {
      print "[ <a href=\"$baseurl/$indexfile\" accesskey='i' rel='index'>Main <span class='hotkey'>i</span>ndex</a> ]\n";
      if ($thread) {
         print "[ <a href=\"$baseurl/$msgdir/$thread-1\.$ext1\#i\" accesskey='t' rel='start'><span class='hotkey'>T</span>hread index</a> ]\n";}
      print "<hr>\n";}
   print "</p><font color=$ecolor><h1>";
   if ($board and $logo) {
      print "<img src='$baseurl/$msgdir/$logo' alt='logo'> &nbsp;\n";}
   print "Error</h1><center><h2>$error</h2>\n</center></font></body>";
   if ($errorlog) {
      open (FIL, ">>$errorlog");
      print (FIL "$date_time, $board: $error - $!\n");
      close (FIL);}
   exit;}

